# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp1
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class BreakRosBackupJob(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'purge_data': 'str',
        'delete_snaphots': 'str'
    }

    attribute_map = {
        'purge_data': 'purge_data',
        'delete_snaphots': 'delete_snaphots'
    }

    def __init__(self, purge_data=None, delete_snaphots=None, _configuration=None):  # noqa: E501
        """BreakRosBackupJob - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._purge_data = None
        self._delete_snaphots = None
        self.discriminator = None

        self.purge_data = purge_data
        self.delete_snaphots = delete_snaphots

    @property
    def purge_data(self):
        """Gets the purge_data of this BreakRosBackupJob.  # noqa: E501


        :return: The purge_data of this BreakRosBackupJob.  # noqa: E501
        :rtype: str
        """
        return self._purge_data

    @purge_data.setter
    def purge_data(self, purge_data):
        """Sets the purge_data of this BreakRosBackupJob.


        :param purge_data: The purge_data of this BreakRosBackupJob.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and purge_data is None:
            raise ValueError("Invalid value for `purge_data`, must not be `None`")  # noqa: E501
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                purge_data not in allowed_values):
            raise ValueError(
                "Invalid value for `purge_data` ({0}), must be one of {1}"  # noqa: E501
                .format(purge_data, allowed_values)
            )

        self._purge_data = purge_data

    @property
    def delete_snaphots(self):
        """Gets the delete_snaphots of this BreakRosBackupJob.  # noqa: E501


        :return: The delete_snaphots of this BreakRosBackupJob.  # noqa: E501
        :rtype: str
        """
        return self._delete_snaphots

    @delete_snaphots.setter
    def delete_snaphots(self, delete_snaphots):
        """Sets the delete_snaphots of this BreakRosBackupJob.


        :param delete_snaphots: The delete_snaphots of this BreakRosBackupJob.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and delete_snaphots is None:
            raise ValueError("Invalid value for `delete_snaphots`, must not be `None`")  # noqa: E501
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                delete_snaphots not in allowed_values):
            raise ValueError(
                "Invalid value for `delete_snaphots` ({0}), must be one of {1}"  # noqa: E501
                .format(delete_snaphots, allowed_values)
            )

        self._delete_snaphots = delete_snaphots

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BreakRosBackupJob, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BreakRosBackupJob):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BreakRosBackupJob):
            return True

        return self.to_dict() != other.to_dict()
