# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp1
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class ChangeEncryptionToAwsKms(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'current_encryption_pwd': 'str',
        'region': 'str',
        'key_id': 'str',
        'access_id': 'str',
        'secret': 'str'
    }

    attribute_map = {
        'current_encryption_pwd': 'current_encryption_pwd',
        'region': 'region',
        'key_id': 'key_id',
        'access_id': 'access_id',
        'secret': 'secret'
    }

    def __init__(self, current_encryption_pwd=None, region=None, key_id=None, access_id=None, secret=None, _configuration=None):  # noqa: E501
        """ChangeEncryptionToAwsKms - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._current_encryption_pwd = None
        self._region = None
        self._key_id = None
        self._access_id = None
        self._secret = None
        self.discriminator = None

        self.current_encryption_pwd = current_encryption_pwd
        self.region = region
        self.key_id = key_id
        self.access_id = access_id
        self.secret = secret

    @property
    def current_encryption_pwd(self):
        """Gets the current_encryption_pwd of this ChangeEncryptionToAwsKms.  # noqa: E501

        Current master encryption password.  # noqa: E501

        :return: The current_encryption_pwd of this ChangeEncryptionToAwsKms.  # noqa: E501
        :rtype: str
        """
        return self._current_encryption_pwd

    @current_encryption_pwd.setter
    def current_encryption_pwd(self, current_encryption_pwd):
        """Sets the current_encryption_pwd of this ChangeEncryptionToAwsKms.

        Current master encryption password.  # noqa: E501

        :param current_encryption_pwd: The current_encryption_pwd of this ChangeEncryptionToAwsKms.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and current_encryption_pwd is None:
            raise ValueError("Invalid value for `current_encryption_pwd`, must not be `None`")  # noqa: E501

        self._current_encryption_pwd = current_encryption_pwd

    @property
    def region(self):
        """Gets the region of this ChangeEncryptionToAwsKms.  # noqa: E501

        The AWS KMS region code to set.  # noqa: E501

        :return: The region of this ChangeEncryptionToAwsKms.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this ChangeEncryptionToAwsKms.

        The AWS KMS region code to set.  # noqa: E501

        :param region: The region of this ChangeEncryptionToAwsKms.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and region is None:
            raise ValueError("Invalid value for `region`, must not be `None`")  # noqa: E501

        self._region = region

    @property
    def key_id(self):
        """Gets the key_id of this ChangeEncryptionToAwsKms.  # noqa: E501

        The AWS KMS key id to set.  # noqa: E501

        :return: The key_id of this ChangeEncryptionToAwsKms.  # noqa: E501
        :rtype: str
        """
        return self._key_id

    @key_id.setter
    def key_id(self, key_id):
        """Sets the key_id of this ChangeEncryptionToAwsKms.

        The AWS KMS key id to set.  # noqa: E501

        :param key_id: The key_id of this ChangeEncryptionToAwsKms.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and key_id is None:
            raise ValueError("Invalid value for `key_id`, must not be `None`")  # noqa: E501

        self._key_id = key_id

    @property
    def access_id(self):
        """Gets the access_id of this ChangeEncryptionToAwsKms.  # noqa: E501

        The AWS KMS access id to set.  # noqa: E501

        :return: The access_id of this ChangeEncryptionToAwsKms.  # noqa: E501
        :rtype: str
        """
        return self._access_id

    @access_id.setter
    def access_id(self, access_id):
        """Sets the access_id of this ChangeEncryptionToAwsKms.

        The AWS KMS access id to set.  # noqa: E501

        :param access_id: The access_id of this ChangeEncryptionToAwsKms.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and access_id is None:
            raise ValueError("Invalid value for `access_id`, must not be `None`")  # noqa: E501

        self._access_id = access_id

    @property
    def secret(self):
        """Gets the secret of this ChangeEncryptionToAwsKms.  # noqa: E501

        The AWS KMS secret password to set.  # noqa: E501

        :return: The secret of this ChangeEncryptionToAwsKms.  # noqa: E501
        :rtype: str
        """
        return self._secret

    @secret.setter
    def secret(self, secret):
        """Sets the secret of this ChangeEncryptionToAwsKms.

        The AWS KMS secret password to set.  # noqa: E501

        :param secret: The secret of this ChangeEncryptionToAwsKms.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and secret is None:
            raise ValueError("Invalid value for `secret`, must not be `None`")  # noqa: E501

        self._secret = secret

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChangeEncryptionToAwsKms, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChangeEncryptionToAwsKms):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ChangeEncryptionToAwsKms):
            return True

        return self.to_dict() != other.to_dict()
