# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp1
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class CreateVolumeSnapshot(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'display_name': 'str',
        'ondemand': 'bool',
        'managedfor': 'str'
    }

    attribute_map = {
        'display_name': 'display_name',
        'ondemand': 'ondemand',
        'managedfor': 'managedfor'
    }

    def __init__(self, display_name=None, ondemand=None, managedfor=None, _configuration=None):  # noqa: E501
        """CreateVolumeSnapshot - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._display_name = None
        self._ondemand = None
        self._managedfor = None
        self.discriminator = None

        self.display_name = display_name
        if ondemand is not None:
            self.ondemand = ondemand
        if managedfor is not None:
            self.managedfor = managedfor

    @property
    def display_name(self):
        """Gets the display_name of this CreateVolumeSnapshot.  # noqa: E501

        The new snapshot name  # noqa: E501

        :return: The display_name of this CreateVolumeSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this CreateVolumeSnapshot.

        The new snapshot name  # noqa: E501

        :param display_name: The display_name of this CreateVolumeSnapshot.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def ondemand(self):
        """Gets the ondemand of this CreateVolumeSnapshot.  # noqa: E501

        Indicate whether snapshot is on-demand.  # noqa: E501

        :return: The ondemand of this CreateVolumeSnapshot.  # noqa: E501
        :rtype: bool
        """
        return self._ondemand

    @ondemand.setter
    def ondemand(self, ondemand):
        """Sets the ondemand of this CreateVolumeSnapshot.

        Indicate whether snapshot is on-demand.  # noqa: E501

        :param ondemand: The ondemand of this CreateVolumeSnapshot.  # noqa: E501
        :type: bool
        """

        self._ondemand = ondemand

    @property
    def managedfor(self):
        """Gets the managedfor of this CreateVolumeSnapshot.  # noqa: E501

        For externally managed VPSA, set what the snapshot is managed for.  # noqa: E501

        :return: The managedfor of this CreateVolumeSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._managedfor

    @managedfor.setter
    def managedfor(self, managedfor):
        """Sets the managedfor of this CreateVolumeSnapshot.

        For externally managed VPSA, set what the snapshot is managed for.  # noqa: E501

        :param managedfor: The managedfor of this CreateVolumeSnapshot.  # noqa: E501
        :type: str
        """

        self._managedfor = managedfor

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateVolumeSnapshot, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateVolumeSnapshot):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateVolumeSnapshot):
            return True

        return self.to_dict() != other.to_dict()
