# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp1
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Vpsa.configuration import Configuration


class SetSmbCharset(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'unix_charset': 'str',
        'dos_charset': 'str',
        'force': 'str'
    }

    attribute_map = {
        'unix_charset': 'unix_charset',
        'dos_charset': 'dos_charset',
        'force': 'force'
    }

    def __init__(self, unix_charset=None, dos_charset=None, force=None, _configuration=None):  # noqa: E501
        """SetSmbCharset - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._unix_charset = None
        self._dos_charset = None
        self._force = None
        self.discriminator = None

        self.unix_charset = unix_charset
        self.dos_charset = dos_charset
        if force is not None:
            self.force = force

    @property
    def unix_charset(self):
        """Gets the unix_charset of this SetSmbCharset.  # noqa: E501

        The unix smb charset to set  # noqa: E501

        :return: The unix_charset of this SetSmbCharset.  # noqa: E501
        :rtype: str
        """
        return self._unix_charset

    @unix_charset.setter
    def unix_charset(self, unix_charset):
        """Sets the unix_charset of this SetSmbCharset.

        The unix smb charset to set  # noqa: E501

        :param unix_charset: The unix_charset of this SetSmbCharset.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and unix_charset is None:
            raise ValueError("Invalid value for `unix_charset`, must not be `None`")  # noqa: E501

        self._unix_charset = unix_charset

    @property
    def dos_charset(self):
        """Gets the dos_charset of this SetSmbCharset.  # noqa: E501

        The dos smb charset to set  # noqa: E501

        :return: The dos_charset of this SetSmbCharset.  # noqa: E501
        :rtype: str
        """
        return self._dos_charset

    @dos_charset.setter
    def dos_charset(self, dos_charset):
        """Sets the dos_charset of this SetSmbCharset.

        The dos smb charset to set  # noqa: E501

        :param dos_charset: The dos_charset of this SetSmbCharset.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and dos_charset is None:
            raise ValueError("Invalid value for `dos_charset`, must not be `None`")  # noqa: E501

        self._dos_charset = dos_charset

    @property
    def force(self):
        """Gets the force of this SetSmbCharset.  # noqa: E501


        :return: The force of this SetSmbCharset.  # noqa: E501
        :rtype: str
        """
        return self._force

    @force.setter
    def force(self, force):
        """Sets the force of this SetSmbCharset.


        :param force: The force of this SetSmbCharset.  # noqa: E501
        :type: str
        """
        allowed_values = ["YES", "NO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                force not in allowed_values):
            raise ValueError(
                "Invalid value for `force` ({0}), must be one of {1}"  # noqa: E501
                .format(force, allowed_values)
            )

        self._force = force

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SetSmbCharset, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetSmbCharset):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetSmbCharset):
            return True

        return self.to_dict() != other.to_dict()
