# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp1
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class InlineResponse20018ResponseQuotaEnabledContainers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'container_name': 'str',
        'total_bytes': 'str',
        'quota_bytes': 'str',
        'warning_threshold': 'str',
        'emergency_threshold': 'str',
        'notify_account_admin': 'str'
    }

    attribute_map = {
        'container_name': 'container_name',
        'total_bytes': 'total_bytes',
        'quota_bytes': 'quota_bytes',
        'warning_threshold': 'warning_threshold',
        'emergency_threshold': 'emergency_threshold',
        'notify_account_admin': 'notify_account_admin'
    }

    def __init__(self, container_name=None, total_bytes=None, quota_bytes=None, warning_threshold=None, emergency_threshold=None, notify_account_admin=None, _configuration=None):  # noqa: E501
        """InlineResponse20018ResponseQuotaEnabledContainers - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._container_name = None
        self._total_bytes = None
        self._quota_bytes = None
        self._warning_threshold = None
        self._emergency_threshold = None
        self._notify_account_admin = None
        self.discriminator = None

        if container_name is not None:
            self.container_name = container_name
        if total_bytes is not None:
            self.total_bytes = total_bytes
        if quota_bytes is not None:
            self.quota_bytes = quota_bytes
        if warning_threshold is not None:
            self.warning_threshold = warning_threshold
        if emergency_threshold is not None:
            self.emergency_threshold = emergency_threshold
        if notify_account_admin is not None:
            self.notify_account_admin = notify_account_admin

    @property
    def container_name(self):
        """Gets the container_name of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501


        :return: The container_name of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :rtype: str
        """
        return self._container_name

    @container_name.setter
    def container_name(self, container_name):
        """Sets the container_name of this InlineResponse20018ResponseQuotaEnabledContainers.


        :param container_name: The container_name of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :type: str
        """

        self._container_name = container_name

    @property
    def total_bytes(self):
        """Gets the total_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501


        :return: The total_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :rtype: str
        """
        return self._total_bytes

    @total_bytes.setter
    def total_bytes(self, total_bytes):
        """Sets the total_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.


        :param total_bytes: The total_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :type: str
        """

        self._total_bytes = total_bytes

    @property
    def quota_bytes(self):
        """Gets the quota_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501


        :return: The quota_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :rtype: str
        """
        return self._quota_bytes

    @quota_bytes.setter
    def quota_bytes(self, quota_bytes):
        """Sets the quota_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.


        :param quota_bytes: The quota_bytes of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :type: str
        """

        self._quota_bytes = quota_bytes

    @property
    def warning_threshold(self):
        """Gets the warning_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501


        :return: The warning_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :rtype: str
        """
        return self._warning_threshold

    @warning_threshold.setter
    def warning_threshold(self, warning_threshold):
        """Sets the warning_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.


        :param warning_threshold: The warning_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :type: str
        """

        self._warning_threshold = warning_threshold

    @property
    def emergency_threshold(self):
        """Gets the emergency_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501


        :return: The emergency_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :rtype: str
        """
        return self._emergency_threshold

    @emergency_threshold.setter
    def emergency_threshold(self, emergency_threshold):
        """Sets the emergency_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.


        :param emergency_threshold: The emergency_threshold of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :type: str
        """

        self._emergency_threshold = emergency_threshold

    @property
    def notify_account_admin(self):
        """Gets the notify_account_admin of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501


        :return: The notify_account_admin of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :rtype: str
        """
        return self._notify_account_admin

    @notify_account_admin.setter
    def notify_account_admin(self, notify_account_admin):
        """Sets the notify_account_admin of this InlineResponse20018ResponseQuotaEnabledContainers.


        :param notify_account_admin: The notify_account_admin of this InlineResponse20018ResponseQuotaEnabledContainers.  # noqa: E501
        :type: str
        """

        self._notify_account_admin = notify_account_admin

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20018ResponseQuotaEnabledContainers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20018ResponseQuotaEnabledContainers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse20018ResponseQuotaEnabledContainers):
            return True

        return self.to_dict() != other.to_dict()
