# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09-sp1
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class InlineResponse20025ResponseMessages(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'msg_id': 'str',
        'msg_title': 'str',
        'msg_severity': 'str',
        'msg_time': 'str'
    }

    attribute_map = {
        'msg_id': 'msg_id',
        'msg_title': 'msg_title',
        'msg_severity': 'msg_severity',
        'msg_time': 'msg_time'
    }

    def __init__(self, msg_id=None, msg_title=None, msg_severity=None, msg_time=None, _configuration=None):  # noqa: E501
        """InlineResponse20025ResponseMessages - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._msg_id = None
        self._msg_title = None
        self._msg_severity = None
        self._msg_time = None
        self.discriminator = None

        if msg_id is not None:
            self.msg_id = msg_id
        if msg_title is not None:
            self.msg_title = msg_title
        if msg_severity is not None:
            self.msg_severity = msg_severity
        if msg_time is not None:
            self.msg_time = msg_time

    @property
    def msg_id(self):
        """Gets the msg_id of this InlineResponse20025ResponseMessages.  # noqa: E501


        :return: The msg_id of this InlineResponse20025ResponseMessages.  # noqa: E501
        :rtype: str
        """
        return self._msg_id

    @msg_id.setter
    def msg_id(self, msg_id):
        """Sets the msg_id of this InlineResponse20025ResponseMessages.


        :param msg_id: The msg_id of this InlineResponse20025ResponseMessages.  # noqa: E501
        :type: str
        """

        self._msg_id = msg_id

    @property
    def msg_title(self):
        """Gets the msg_title of this InlineResponse20025ResponseMessages.  # noqa: E501


        :return: The msg_title of this InlineResponse20025ResponseMessages.  # noqa: E501
        :rtype: str
        """
        return self._msg_title

    @msg_title.setter
    def msg_title(self, msg_title):
        """Sets the msg_title of this InlineResponse20025ResponseMessages.


        :param msg_title: The msg_title of this InlineResponse20025ResponseMessages.  # noqa: E501
        :type: str
        """

        self._msg_title = msg_title

    @property
    def msg_severity(self):
        """Gets the msg_severity of this InlineResponse20025ResponseMessages.  # noqa: E501


        :return: The msg_severity of this InlineResponse20025ResponseMessages.  # noqa: E501
        :rtype: str
        """
        return self._msg_severity

    @msg_severity.setter
    def msg_severity(self, msg_severity):
        """Sets the msg_severity of this InlineResponse20025ResponseMessages.


        :param msg_severity: The msg_severity of this InlineResponse20025ResponseMessages.  # noqa: E501
        :type: str
        """

        self._msg_severity = msg_severity

    @property
    def msg_time(self):
        """Gets the msg_time of this InlineResponse20025ResponseMessages.  # noqa: E501


        :return: The msg_time of this InlineResponse20025ResponseMessages.  # noqa: E501
        :rtype: str
        """
        return self._msg_time

    @msg_time.setter
    def msg_time(self, msg_time):
        """Sets the msg_time of this InlineResponse20025ResponseMessages.


        :param msg_time: The msg_time of this InlineResponse20025ResponseMessages.  # noqa: E501
        :type: str
        """

        self._msg_time = msg_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20025ResponseMessages, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20025ResponseMessages):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse20025ResponseMessages):
            return True

        return self.to_dict() != other.to_dict()
